<?php
/*
Plugin Name: GetTags-RPC 
Plugin URI: http://brettterpstra.com
Description: Adds an XMLRPC method for getting all available tags from your WordPress blog.
Version: 1.0
Author: Brett Terpstra
*/

$version = 1.0;

function gettags_escape(&$array) {
	global $wpdb;

	foreach ( (array) $array as $k => $v ) {
		if (is_array($v)) {
			gettags_escape($array[$k]);
		} else if (is_object($v)) {
			//skip
		} else {
			$array[$k] = $wpdb->escape($v);
		}
	}
}

function gettags_getTags($args) {
	gettags_escape($args);

  $blog_ID     = $args[0];
  $user_login  = $args[1];
  $user_pass   = $args[2];

  if (!user_pass_ok($user_login, $user_pass)) {
    return;
  }
  return get_tags();
}

add_filter('xmlrpc_methods', 'attach_gettags_xmlrpc');
function attach_gettags_xmlrpc($methods) {
	$methods['metaWeblog.getTags'] = 'gettags_getTags';
	return $methods;
}

?>
